#include "cwd.h"

#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <QString>
#include <QDebug>

#define HOST "localhost"

int cwd::cw_init(){
    // Connect to cwdaemon
    // port used is 6789;
        cw_port = 6789;
        //char cw_hostaddress[16] = "127.0.0.1";// Connect to cwdaemon running on local machine
        char cw_hostaddress[16] = HOST;
        struct hostent *hostbyname;
        hostbyname = gethostbyname (cw_hostaddress);
        if (hostbyname == NULL) return 1;

        bzero (&address, sizeof (address));
        address.sin_family = AF_INET;
        memcpy (&address.sin_addr.s_addr, hostbyname->h_addr,
                 sizeof (address.sin_addr.s_addr));
        address.sin_port = htons (cw_port);

        socket_descriptor = socket (AF_INET, SOCK_DGRAM, 0);
        if (socket_descriptor == -1) return 2;
        return 0;
}

/* close UDP socket */
void cwd::cw_close(){
         close(socket_descriptor);
}


int cwd::cw_send(int cw_op, const char *cwmessage){

        ssize_t sendto_rc = 0;
        char buf[80];

        switch (cw_op)
        {

                case K_MESSAGE:	// cw message
                        snprintf(buf, 80, "%s", cwmessage);
                break;
                case K_SPEED:	// speed
                        snprintf(buf, 80, "%c2%s", 27, cwmessage);
                break;
                case K_ABORT:	// message abort
                    //qDebug() << "DEBUG: ABORT sent" << endl;
                        snprintf(buf, 80, "%c4", 27);
                break;
                default:
                        buf[0] = '\0';
        }

        // This is where the message actually gets sent.
        if (buf[0] != '\0')
        {
                sendto_rc = sendto (socket_descriptor, buf, sizeof (buf), 0,
                                (struct sockaddr *) &address, sizeof (address));
        }
        else
                sendto_rc = -1;
        //free (cwmessage);

        return sendto_rc;
}


