#ifndef XLOGGER_H
#define XLOGGER_H
// xlogger.h
//
// Written by Mike Studer
// 2004-12-22
//


// OS includes
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

class xlogger
{
 private:

  /* structure needed for the message queue */
typedef struct
{
        long int mtype;             // mtype should always be 88
        char mtext[1024];       // mtext holds the message
}
msgtype;
msgtype msgbuf;
int msgid;

 public:

// send data to xlog
   int sendit(char*);
};

#endif // XLOGGER_H
